local hasSolarian = false;
local SolarianTrinket = 30446;
local WrathPieces = {
  [1] = 16963,
  [3] = 16961,
  [5] = 16966,
  [6] = 16960,
  [7] = 16962,
  [8] = 16965,
  [9] = 16959,
  [10] = 16964,
};

local BBSGearTicker;
local hasBagged = false;

local setPieces = {};
local baggedItems = {};
local baggedItemsBackup = {};

local equipQueued = false;
function BBS_HasSwapQueued() return equipQueued end
function BBS_SetQueueStatus(bool) equipQueued = bool end

function BBS_HasBonusEquipped()
  local equipped = 0;
  for slotID, wrathID in pairs(WrathPieces) do
    if(wrathID == GetInventoryItemID("player", slotID)) then
      equipped = equipped + 1;
    end
  end
  return equipped >= 3, equipped;
end

function BBS_EquipBagged()
  for k, v in pairs(baggedItems) do
    if(isInCombat) then return end
    BBS_SetICD(GetTime() + 0.85);
    --if(k ~= 14) then
      EquipItemByName(v, k);
    --else
      --EquipItemByName(v, 14);
      --BBS_EquipBottomTrinket(v);
    --end
    baggedItems[k] = nil;
  end
  equipQueued = false;
  hasBagged = false;
  BBS_ToggleTicker(false);
  BBSGearTicker = C_Timer.After(0.8, function()
    local unequipped = 0;
    for slot, item in pairs(baggedItemsBackup) do
      unequipped = unequipped + 1;
      local equippedName = GetItemInfo(GetInventoryItemLink("player", slot));
      if(equippedName == item) then
        baggedItemsBackup[slot] = nil;
        unequipped = unequipped - 1;
      end
    end
    if(unequipped ~= 0 and not equipQueued) then
      baggedItems = baggedItemsBackup;
      equipQueued = true;
      hasBagged = true;
      print("BAA: Gear swap failed; new swap queued.");
    end
    baggedItemsBackup = {};
  end);
end

function BBS_EquipWrath()
  for slot, name in pairs(setPieces) do
    if(isInCombat) then return end
    local equippedName = GetItemInfo(GetInventoryItemLink("player", slot));
    baggedItems[slot] = equippedName;
    EquipItemByName(name);
  end
  if(hasSolarian) then
    local trinketSlot = BBS_GetTrinketToSwap();
    local equippedName = GetItemInfo(GetInventoryItemLink("player", trinketSlot));
    baggedItems[trinketSlot] = equippedName;
    --if(trinketSlot == 13) then
      EquipItemByName(GetItemInfo(SolarianTrinket), trinketSlot);
    --else
      --BBS_EquipBottomTrinket(SolarianTrinket);
    --end
  end
  hasBagged = true;
  for k, v in pairs(baggedItems) do
    baggedItemsBackup[k] = v;
  end
  equipQueued = false;
  BBS_ToggleTicker(true);
end

function BBS_EquipBottomTrinket(name)
  for bag=0,4 do
    for slot=1,GetContainerNumSlots(bag) do
      if(GetContainerItemLink(bag, slot) or ""):match(name) then
        PickupContainerItem(bag, slot);
        PickupInventoryItem(14);
      end
    end
  end
end

function BBS_DetectNonUseTrinket()
  if(GetItemSpell(GetInventoryItemLink("player", 13)) == nil) then
    return 13;
  elseif(GetItemSpell(GetInventoryItemLink("player", 14)) == nil) then
    return 14;
  else
    return trinketSlot;
  end
end

function BBS_SetWrathPieces()
  local foundPieces = {};
  local priority = {
    [1] = 9,
    [2] = 7,
    [3] = 3,
    [4] = 10,
    [5] = 5,
    [6] = 6,
    [7] = 8,
    [8] = 1,
  };
  local pieceCount = 0;
  for k, v in pairs(priority) do
    local id = WrathPieces[v];
    if(GetItemCount(id) > 0) then
      local name = GetItemInfo(id);
      foundPieces[v] = name;
      pieceCount = pieceCount + 1;
    end
    if(pieceCount == 3) then
      break
    end
  end
  if(pieceCount == 3) then
    setPieces = foundPieces;
  end
  if(GetItemCount(SolarianTrinket) > 0) then
    hasSolarian = true;
  end
end

function BBS_EquipQueued()
  if(not hasBagged) then
    BBS_EquipWrath();
    print("BAA: Equipping 3 set.");
  else
    BBS_EquipBagged();
    print("BAA: Re-equipping.");
  end
  equipQueued = false;
end

function BBS_GetTrinketToSwap()
  local trinketSetting = BBS_GetTrinketSetting();
  if(trinketSetting < 2) then return trinketSetting + 13 end
  local topSpell = GetItemSpell(GetInventoryItemLink("player", 13));
  local botSpell = GetItemSpell(GetInventoryItemLink("player", 14));
  if(topSpell == nil and botSpell == nil) then
    return 11 + trinketSetting;
  elseif(topSpell == nil) then
    return 13;
  elseif(botSpell == nil) then
    return 14;
  end
  local topStart, topDuration,_ = GetItemCooldown(GetInventoryItemID("player", 13));
  local botStart, botDuration,_ = GetItemCooldown(GetInventoryItemID("player", 14));
  if((topStart + topDuration - GetTime()) > (botStart + botDuration - GetTime())) then
    return 13;
  else
    return 14;
  end
end

function BBS_GetTrinketSetting()
  return BBS_CommandSetting or 0;
end

function BBS_IncrementTrinketSetting()
  local settings = {
    [0] = "TOP",
    [1] = "BOTTOM",
    [2] = "AUTO(TOP)",
    [3] = "AUTO(BOTTOM)",
  };
  local n = BBS_GetTrinketSetting();
  n = n + 1;
  if(n > 3) then n = 0 end
  print("BBS: Trinket preference set to: " .. settings[n] .. "(" .. (n + 1) .. "/4)");
  BBS_CommandSetting = n;
end
